import 'package:blocstar/BlocBase.dart';
import 'package:blocstar_example/Modules/Counter/Blocstar/CounterBlocModel.dart';

class CounterBloc extends BlocBase<CounterBlocModel> {
  @override
  Future initializeAsync() async {
    currentModel = new CounterBlocModel(
        count: 0,
        description: "Button Press Count",
        onAppStateChanged: onAppStateChangedCallback);
    sinkDefault();
  }

  buttonPressedAsync() async {
    await runAsync(
        function: () async {
          Future.delayed(new Duration(seconds: 2), _incrementCount);
        },
        timeoutSeconds: 3);
  }

  _incrementCount() {
    currentModel = currentModel.merge(newCount: currentModel.count + 1);
    sinkDefault();
  }
}
